--

with Generic_Collection_Support_Logs;
with Generic_Collection_Ordered_Support_Logs;

with Ada.Text_IO;

generic
   type Item_Type is private;

   with package Collection_Support is new Generic_Collection_Support_Logs (Item_Type);
   use Collection_Support;

   -- -- --

   type Ordered_Item_Type is private;

   with function "<" (L, R : Ordered_Item_Type) return Boolean is <>;

   with package Ordered_Collection_Support is new Generic_Collection_Ordered_Support_Logs (Ordered_Item_Type);
   use Ordered_Collection_Support;

   -- -- --

   with function To_String (Item : Ordered_Item_Type) return String is <>;

   -- -- --

   type Buff_Enum_Type is (<>);

   with function To_Ordered
     (Nb   : Positive;
      B    : Buff_Enum_Type;
      Item : Item_Type)
      return Ordered_Item_Type is <>;

package Generic_Logs_To_Ram is
   use Ada;

   -- -- --

   procedure Save_To_Ram (C : in out Item_Collections.Abstract_Collection'Class; Item : in Item_Type);

   -- -- --

   procedure Sort_In_Ram
     (B  : Buff_Enum_Type;
      Cb : in out Item_Collections.Abstract_Collection'Class;
      Co : in out Item_Ordered_Base_Collections.Abstract_Collection'Class);

   -- -- --

   procedure From_Ram_To_File
     (File : in out Text_IO.File_Type;
      C    : in out Item_Ordered_Base_Collections.Abstract_Collection'Class);

   -- -- --

   function Is_Empty (Co : Item_Collections.Abstract_Collection'Class) return Boolean;

   procedure Clear_Collection (Co : in out Item_Ordered_Base_Collections.Abstract_Collection'Class);

   -- -- --

end Generic_Logs_To_Ram;
