--

package body Generic_Logs_To_Ram is

   -- -- --

   procedure Save_To_Ram (C : in out Item_Collections.Abstract_Collection'Class; Item : in Item_Type) is
   begin
      Item_Collections.Append (C, Item);

   exception
      when E : others =>
         Item_Collections.Clear (C);

         raise;
   end Save_To_Ram;

   -- -- --

   procedure Add_To_Sorted
     (C            : in out Item_Ordered_Base_Collections.Abstract_Collection'Class;
      Ordered_Item : in Ordered_Item_Type) is
   begin
      Item_Ordered_Base_Collections.Append (C, Ordered_Item);

   exception
      when E : others =>
         Item_Ordered_Base_Collections.Clear (C);

         raise;
   end Add_To_Sorted;

   -- -- --

   procedure From_Ram_To_File
     (File : in out Text_IO.File_Type;
      C    : in out Item_Ordered_Base_Collections.Abstract_Collection'Class) is

      It           : Item_Ordered_Containers.Iterator'Class := Item_Ordered_Base_Collections.New_Iterator (C);
      Ordered_Item : Ordered_Item_Type;

   begin

      Item_Ordered_Containers.Reset (It);

      while not Item_Ordered_Containers.Is_Done (It) loop

         Ordered_Item := Item_Ordered_Containers.Current_Item (It);

         Text_IO.Put_Line (File, To_String (Ordered_Item));

         Item_Ordered_Containers.Next (It);
      end loop;

   exception
      when E : others =>
         Item_Ordered_Base_Collections.Clear (C);
         Text_IO.Close (File);

         raise;
   end From_Ram_To_File;

   -- -- --

   procedure Sort_In_Ram
     (B  : Buff_Enum_Type;
      Cb : in out Item_Collections.Abstract_Collection'Class;
      Co : in out Item_Ordered_Base_Collections.Abstract_Collection'Class) is

      It   : Item_Containers.Iterator'Class := Item_Collections.New_Iterator (Cb);
      Item : Item_Type;

      Nb : Positive := 1;

   begin
      Item_Containers.Reset (It);

      while not Item_Containers.Is_Done (It) loop

         Item := Item_Containers.Current_Item (It);

         Add_To_Sorted (Co, To_Ordered (Nb, B, Item));

         Item_Containers.Next (It);

         Nb := Positive'Succ (Nb);
      end loop;

      Item_Collections.Clear (Cb);

   end Sort_In_Ram;

   -- -- --

   function Is_Empty (Co : Item_Collections.Abstract_Collection'Class) return Boolean is
   begin
      return Item_Collections.Is_Empty (Co);
   end Is_Empty;

   -- -- --

   procedure Clear_Collection (Co : in out Item_Ordered_Base_Collections.Abstract_Collection'Class) is
   begin
      Item_Ordered_Base_Collections.Clear (Co);

   end Clear_Collection;

   -- -- --

end Generic_Logs_To_Ram;
