--
with Ada.Text_IO;

package Io_Support is
   use Ada.Text_IO;

   function Str (V : Boolean) return String;

   function Str (V : Integer) return String;

   function Str (V : Float) return String;

   function Mils (V : Float) return String;

   function Str (V : Long_Float) return String;

   function Mils (V : Long_Float) return String;

   -- -- --

   function Put
     (V    : Float;
      Aft  : Field := Float'Digits - 1;
      Exp  : Field := 3)
      return String;

   function Put
     (V    : Long_Float;
      Aft  : Field := Long_Float'Digits - 1;
      Exp  : Field := 3)
      return String;

   -- -- --

   generic
      type Discrete_Type is (<>);
   function Generic_Put_Discrete (V : Discrete_Type) return String;
   --
   --  For enumeration types
   --  For integer types
   --  For signed integer types
   --  For modular types

   -- -- --

   generic
      type Index_Type is (<>);
      type Discrete_Type is (<>);
      type Array_Type is array (Index_Type range <>) of Discrete_Type;

   function Generic_Put_Discrete_Array
     (A     : Array_Type;
      First : Index_Type := Index_Type'First;
      Last  : Index_Type := Index_Type'Last)
      return  String;

   -- -- --

   generic
      type Index_Type is (<>);
      type Discrete_Type is (<>);
      type Array_Type is array (Index_Type) of Discrete_Type;

   function Generic_Put_Discrete_Constrained_Array (A : in Array_Type) return String;

   -- -- --

   generic
      type Index_Type is (<>);
      type Floating_Type is digits <>;
      type Array_Type is array (Index_Type range <>) of Floating_Type;

   function Generic_Put_Floating_Array
     (A     : Array_Type;
      First : Index_Type := Index_Type'First;
      Last  : Index_Type := Index_Type'Last)
      return  String;

   -- -- --

   generic
      type Index_Type is (<>);
      type Floating_Type is digits <>;
      type Array_Type is array (Index_Type) of Floating_Type;

   function Generic_Put_Floating_Constrained_Array (A : Array_Type) return String;

   -- -- --

end Io_Support;
