--

with Ada.Text_IO;

with Table3.Lines;

package body Logs_Buffer is
   use Ada;
   use Table3;

   procedure Read_Config_Data (Config_Data : in out Do_Log_This_Buff_Array_Type) is
      As_Read_File        : Text_IO.File_Type;
      Actual_Line_In_File : Natural := 0;

      package Task_Enum_Io is new Text_IO.Enumeration_IO (Buff_Enum_Type);
      use Task_Enum_Io;

      package Boolean_Io is new Text_IO.Enumeration_IO (Boolean);
      use Boolean_Io;

   begin

      Open_Text_File : declare
      begin
         Text_IO.Open (File => As_Read_File, Mode => Text_IO.In_File, Name => Read_File_Name);

      exception
         when others =>
            return;
      end Open_Text_File;

      -- -- --

      declare
         Local_Config_Data : Do_Log_This_Buff_Array_Type;
      begin

         while not Text_IO.End_Of_File (As_Read_File) loop

            Actual_Line_In_File := Lines.Get_Line (As_Read_File);

            declare
               Last            : Positive;
               Task_Enum       : Buff_Enum_Type;
               Task_Enum_Value : Boolean;

               F1 : String := Lines.Get_Field (1);
               F2 : String := Lines.Get_Field (2);
               F3 : String := Lines.Get_Field (3);

            begin

               if With_Ouput then
                  Text_IO.Put (">>>> " & F1 & " | ");

                  Get (F2, Task_Enum, Last);
                  Text_IO.Put (Buff_Enum_Type'Image (Task_Enum) & " | ");

                  Get (F3, Task_Enum_Value, Last);
                  Text_IO.Put_Line (Boolean'Image (Task_Enum_Value));
               end if;

               Local_Config_Data (Task_Enum) := Task_Enum_Value;

            exception
               when others =>
                  return;
            end;

         end loop;

         Config_Data := Local_Config_Data;

      exception
         when others =>
            return;
      end;

      -- -- --

      Text_IO.Close (As_Read_File);

   end Read_Config_Data;

end Logs_Buffer;
