
with Ada.Strings.Bounded;

package Logs_Items is

   Max_Time_Stamp_Length    : Natural := 12;
   Max_Seconds_Stamp_Length : Natural := 12;
   Max_Task_Name_Length     : Natural := 7;
   Max_Message_Length       : Natural := 61;

   package Bounded_Ts is new Ada.Strings.Bounded.Generic_Bounded_Length (Max_Time_Stamp_Length);
   use Bounded_Ts;

   package Bounded_Ts_S is new Ada.Strings.Bounded.Generic_Bounded_Length (Max_Seconds_Stamp_Length);
   use Bounded_Ts_S;

   package Bounded_Tn is new Ada.Strings.Bounded.Generic_Bounded_Length (Max_Task_Name_Length);
   use Bounded_Tn;

   package Bounded_Ms is new Ada.Strings.Bounded.Generic_Bounded_Length (Max_Message_Length);
   use Bounded_Ms;

   type Log_Item_Type is record
      Ts   : Bounded_Ts.Bounded_String; --  Time stamp
      Ts_S : Bounded_Ts_S.Bounded_String; --  Seconds stamp
      Tn   : Bounded_Tn.Bounded_String; --  Task name
      Ms   : Bounded_Ms.Bounded_String; --  User message
   end record;

end Logs_Items;
