--

with Ada.Integer_Text_IO;
with Ada.Strings.Fixed;

separate (Logs_To_Ram)
package body Ordered_Item_To_String is
   use Ada;
   use Ada.Strings;

   Max_Time_Stamp_Length    : Natural := 12;
   Max_Seconds_Stamp_Length : Natural := 12;
   Max_Task_Name_Length     : Natural := 7;
   Max_Nb_Length            : Natural := 6;

   -- -- --

   function To_String (Ordered_Item : Ordered_Item_Type) return String is
      Ts_H_Str : String (1 .. Max_Time_Stamp_Length);
      Ts_S_Str : String (1 .. Max_Seconds_Stamp_Length);
      Tn_Str   : String (1 .. Max_Task_Name_Length);
      Nb_Str   : String (1 .. Max_Nb_Length);

      Ms_Str : String := Bounded_Ms.To_String (Ordered_Item.Ms);

      Sep : String := " | ";

   begin

      Ts_H_Str := Lada.Image (Ordered_Item.Ts) (12 .. 23);
      --
      --  With hours, etc

      Fixed.Overwrite (Ts_H_Str, Fixed.Index (Ts_H_Str, "."), ",");

      Ts_S_Str := Lada.Image_In_Seconds (Ordered_Item.Ts) (2 .. 13);
      --
      --  In seconds

      Fixed.Overwrite (Ts_S_Str, Fixed.Index (Ts_S_Str, "."), ",");

      Tn_Str := Logs_Buffer.Buffs_Shortname_Array (Ordered_Item.Tg);
      --
      --  Name of task

      Integer_Text_IO.Put (Nb_Str, Ordered_Item.Nb);
      --
      --  Counter in each task

      return (Ts_H_Str & Sep & Ts_S_Str & Sep & Tn_Str & Sep & Nb_Str & Sep & Ms_Str);

   end To_String;

   -- -- --

end Ordered_Item_To_String;
