--

with Ada.Strings;

package body Table3.Lines is
   use Ada;
   use Ada.Strings;

   -- -- --

   Buffer : String (1 .. Max_Nb_Of_Chars) := (others => ' ');

   -- -- --

   Length_Of_Line : Natural;

   Line : Bounded.Bounded_String;

   Field : array (Field_Index_Type) of Bounded.Bounded_String;

   Index_Of_Field_Seperator_1 : Natural;
   Index_Of_Field_Seperator_2 : Natural;

   -- -- --

   function Get_Line (F : Text_IO.File_Type) return Natural is
      function Bounded_Slice
        (Source : Bounded.Bounded_String;
         Low    : Positive;
         High   : Natural)
         return   Bounded.Bounded_String
      is
      begin
         return Bounded.To_Bounded_String (Bounded.Slice (Source, Low, High));
      end Bounded_Slice;

   begin

      Text_IO.Get_Line (File => F, Item => Buffer, Last => Length_Of_Line);

      Line := Bounded.To_Bounded_String (Buffer (1 .. Length_Of_Line));

      Index_Of_Field_Seperator_1 := Bounded.Index (Line, Field_Seperator);
      Index_Of_Field_Seperator_2 := Bounded.Index (Line, Field_Seperator, Backward);

      Field (1) := Bounded_Slice (Line, 1, Index_Of_Field_Seperator_1 - 1);
      Field (1) := Bounded.Trim (Field (1), Side => Both);

      Field (2) := Bounded_Slice (Line, Index_Of_Field_Seperator_1 + 1, Index_Of_Field_Seperator_2 - 1);
      Field (2) := Bounded.Trim (Field (2), Side => Both);

      Field (3) := Bounded_Slice (Line, Index_Of_Field_Seperator_2 + 1, Length_Of_Line);
      Field (3) := Bounded.Trim (Field (3), Side => Both);

      if False then
         Text_IO.Put_Line ("> Line: <" & Buffer (1 .. Length_Of_Line) & ">");
         Text_IO.Put_Line ("> Field_1: <" & Bounded.To_String (Field (1)) & ">");
         Text_IO.Put_Line ("> Field_2: <" & Bounded.To_String (Field (2)) & ">");
         Text_IO.Put_Line ("> Field_3: <" & Bounded.To_String (Field (3)) & ">");
      end if;

      return Natural (Text_IO.Line (F));
   end Get_Line;

   -- -- --

   function Get_Field (FI : Field_Index_Type) return String is
   begin
      return Bounded.To_String (Field (Fi));
   end Get_Field;

end Table3.Lines;
