--

with Ada.Text_IO;

with Logs_Buffer;
with Logs_To_Ram;
with Logs_To_Ram.Re;

procedure Logs_To_Ram_Test is
   use Ada;
   use Logs_Buffer;
   use Logs_To_Ram;

   subtype Index_Type is Integer range 1 .. 3;
   type Float_Array_Type is array (Index_Type) of Float;

   function Put_Floating_Constrained_Array is new Generic_Put_Floating_Constrained_Array (
      Index_Type,
      Float,
      Float_Array_Type);

   Float_Array : Float_Array_Type := (1.234, 10000.0, -200.0003);

begin

   Text_IO.Put_Line ("#### Logs_To_Ram_Test ...");

   Do_Log_To_Ram (0, "1- 123456789");

   Do_Log_To_Ram (0, "2- abcdefghi");

   Do_Log_To_Ram (1, "3- #<<<<<<<<<                                   >>>>>>>>>>>>>*");

   Do_Log_To_Ram (1, "4- 123456789");

   Do_Log_To_Ram (1, "5a- abcdefghi", "def");

   Do_Log_To_Ram (1, "5b- abcdefghi", "345");

   Do_Log_To_Ram (1, "5c- abcDEFghi", "def");

   Do_Log_To_Ram (1, "6- #<<<<<<<<<                                   >>>>>>>>>>>>>*");

   Do_Log_To_Ram
     (1,
      "7- #<<<<<<<<<              xxxxxxxxxxxxxxxxxxxxxxxxxxxxx    >>>>" &
      ">>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>*");

   Do_Log_To_Ram (1, "8- " & Str (123) & Str (Float (4.56789)));

   Do_Log_To_Ram
     (1,
      "9a- #<<<<<<<< <Xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx>>>>>>>>>>>> >  * ");
   Do_Log_To_Ram
     (1,
      "9b- #<<<<<<<< <Xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx>>>>>>>>>>>> >  * ");
   Do_Log_To_Ram
     (1,
      "9c- #<<<<<<<< <Xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx>>>>>>>>>>>> >  * ");

   Do_Log_To_Ram (0, "10- " & Put_Floating_Constrained_Array (Float_Array));

   -- -- --
   -- -- --

   Append_To_Log_Item (2, "11- " & Put_Floating_Constrained_Array (Float_Array));
   Append_To_Log_Item (2, Sep & "an array");
   Do_Log_Item_To_Ram (2);

   Append_To_Log_Item (2, "12- " & Put_Floating_Constrained_Array (Float_Array));
   Append_To_Log_Item (2, Sep & "an array");

   Do_Log_Item_To_Ram (2);

   -- -- --
   -- -- --

   Append_To_Log_Item (3, "13- ");
   Append_To_Log_Item (3, Sep & "noarray");
   Do_Log_Item_To_Ram (3);

   Re.Compile (Pos => 3, P => "[a-z]+");

   Append_To_Log_Item (3, "14- ");
   Re.Append_To_Log_With_Re (3, "match: ", "noarray");

   Do_Log_Item_To_Ram (3);

   Append_To_Log_Item (3, "15- ");
   Re.Append_To_Log_With_Re (3, "no match: ", "12346789");

   Do_Log_Item_To_Ram (3);

   Append_To_Log_Item (3, "16- ");
   Re.Append_To_Log_With_Re (3, "match: ", "noarray");

   Do_Log_Item_To_Ram (3);

   -- -- --
   -- -- --

   Save_Logs_To_File;

   Text_IO.Put_Line ("#### Logs_To_Ram_Test.");

   Text_IO.Skip_Line;

end Logs_To_Ram_Test;
