---

with Ada.Text_IO;

with Table3.Lines;

procedure Table3.Test is
   use Ada;
   use Table3;

   As_Read_File        : Text_IO.File_Type;
   Actual_Line_In_File : Natural := 0;

   Read_File_Name : String := "log_to_ram.cfg";
--
--  Name of the text data file to be read

-- -- --
begin
   Text_IO.New_Line;
   Text_IO.Put_Line ("# Table3.Test ...");
   Text_IO.New_Line;

   -- -- --

   Open_Text_File : declare
   begin
      Text_IO.Open (File => As_Read_File, Mode => Text_IO.In_File, Name => Read_File_Name);

   exception
      when others =>
         Text_IO.Put_Line ("! Exception when opening text file");
         raise;
   end Open_Text_File;

   -- -- --

   declare
   begin

      while not Text_IO.End_Of_File (As_Read_File) loop

         Actual_Line_In_File := Lines.Get_Line (As_Read_File);

         declare
            F1 : String := Lines.Get_Field (1);
            F2 : String := Lines.Get_Field (2);
            F3 : String := Lines.Get_Field (3);

         begin

            Text_IO.New_Line;

         exception
            when others =>
               Text_IO.New_Line;
               Text_IO.Put_Line ("! Exception when printing");
               raise;
         end;

      end loop;

   exception
      when others =>
         Text_IO.New_Line;
         Text_IO.Put_Line ("! Exception when reading");
         Text_IO.Put_Line ("! Line Nb: " & Actual_Line_In_File'Img);
         raise;
   end;

   -- -- --

   Text_IO.Close (As_Read_File);

   Text_IO.Put_Line ("# Table_Types.Test.");

   declare
      Chr : Character;
   begin
      Text_IO.Get_Immediate (Chr);
   end;

exception
   when others =>
      Text_IO.Close (As_Read_File);
      Text_IO.New_Line;
      Text_IO.Put_Line ("! Exception in Table_Types.Test.");

      declare
         Chr : Character;
      begin
         Text_IO.Get_Immediate (Chr);
      end;

end Table3.Test;
