--

with Ada.Strings.Bounded;

with Logs_Items;

package Logs_Buffer is
   pragma Elaborate_Body;

   -- -- --

   Max_Message_Length : constant Natural := 3 * 80;

   -- -- --

   type Buff_Enum_Type is (
     Buff0, --  0
     Buff1, --  1
     Buff2, --  2
     Buff3, --  3
     Buff4, --  4
     Buff5  --  5
     );

   --
   --  ### Genau 5 Zeichen fr jeden Wert!
   --  ### Mit jedem Wert wird eine Buff identifiziert.
   --  ### Der Wert wird der Logging-Prozedur Log_To_Ram bergeben.

   -- -- --

   type Do_Log_This_Buff_Array_Type is array (Buff_Enum_Type) of Boolean;

   Do_Log_This_Buff_Array : Do_Log_This_Buff_Array_Type :=
     (Buff0 => False,
      Buff1 => False,
      Buff2 => False,
      Buff3 => False,
      Buff4 => False,
      Buff5 => False);
   --
   --  ### Ist ein Wert auf False gesetzt, wird in dem zugeordneten Puffer nicht geloggt.
   --  ### Diese Werte werden nur verwendet, wenn keine Konfigurationddatei log_to_ram.cfg
   --  ### vorhanden ist (log_to_ram.cfg => log_to_ram.cfgx).

   -- -- --

   Buffs_Shortname_Array : array (Buff_Enum_Type) of String (1 .. Logs_Items.Max_Task_Name_Length) :=
     (Buff0 => "0_Buff ",
      Buff1 => "1_Buff ",
      Buff2 => "2_Buff ",
      Buff3 => "3_Buff ",
      Buff4 => "4_Buff ",
      Buff5 => "5_Buff ");
   --
   --  ### Genau 7 Zeichen fr jeden Namen!
   --  ### Der Name wird in die Logging-Datei verwendet.

   -- -- --
   -- -- --

   Read_File_Name : String := "log_to_ram.cfg";
   --
   --  ### Name der Konfigurationddatei
   --  ### Aufbau der Datei:
   --  ### Fr jeden Wert von Buff_Enum_Type gibt es eine Zeile der Form
   --
   --  Dmg_Controller         : Buff0  :  False
   --  ----------------------------------------
   --  Kommentar,Z>0           Buff,Z=5   True/False
   --
   --  ### Z=Zeichenzahl; Feldtrenner ist der Doppelpunkt.
   --  ### Leerzeichen werden berlesen. Keine Tabulatoren, keine Leerzeilen!
   --  ### Ist keine Konfigurationddatei vorhanden oder treten beim Lesen Probleme auf,
   --  ### so werden die hartcodieren Werte verwendet - siehe oben.

   -- -- --
   -- -- --

   With_Ouput : Boolean := True;
   --
   --  ### Gibt aus, mit welchen Puffern geloggt wird.

   -- -- --

   procedure Read_Config_Data (Config_Data : in out Do_Log_This_Buff_Array_Type);

   -- -- --

   package Bounded_Ms is new Ada.Strings.Bounded.Generic_Bounded_Length (Logs_Buffer.Max_Message_Length);


end Logs_Buffer;
