--

with Reg_Exp;

package Logs_To_Ram.Re is
   use Reg_Exp;

   --  subtype Regexp is Reg_Exp.Regexp;
   --
   --  ObjectAda does not like this

   function Compile (P : String; Cs : Boolean := False) return Regexp;
   --
   --  P is for the pattern string; Cs is for Case_Sensitive

   --  Precondition: Usage of Compile to build the regular expression Re
   --
   procedure Append_To_Log_With_Re
     (Pos : in Pos_Nb_Type;
      S1  : in String;
   --
      S2  : in String;
      Re  : in Regexp;
   --
      S3  : String := "");
   --
   --  The string S1 & S2 & S3 is appended to the log string only
   --  when S2 exactly matches the regular expression Re;
   --  otherwise the log string built so far is set to the empty string

   -- -- --
   -- -- --

   procedure Compile (Pos : in Pos_Nb_Type; P : in String; Cs : in Boolean := False);
   --
   --  P is for the pattern string; the regular expression is
   --  associated with buffer B
   --  Cs is for Case_Sensitive

   -- -- --

   --  Precondition: Usage of Compile to build the regular
   --  expression Re associated with buffer B
   --
   procedure Append_To_Log_With_Re
     (Pos : in Pos_Nb_Type;
   --
      S1  : in String;
      S2  : in String;
      S3  : in String := "");
   --
   --  The string S1 & S2 & S2is appended to the log string only
   --  when S2 exactly matches the regular expression prior
   --  compiled for the buffer B; otherwise the log string built
   --  so far is set to the empty string

   -- -- --

private

   procedure Append_To_Log_With_Re
     (B  : in Buff_Enum_Type;
      S1 : in String;
   --
      S2 : in String;
      Re : in Regexp;
   --
      S3 : String := "");

   procedure Compile (B : in Buff_Enum_Type; P : in String; Cs : in Boolean := False);

   procedure Append_To_Log_With_Re
     (B  : in Buff_Enum_Type;
   --
      S1 : in String;
      S2 : in String;
      S3 : in String := "");

end Logs_To_Ram.Re;
